import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.cfg.AnnotationConfiguration;
import org.hibernate.cfg.Configuration;
import org.junit.Before;
import org.junit.Test;

import java.io.File;


public class Test1 {
    private static Configuration config;
    private static SessionFactory factory;



    @Before
    public void init() {
        config = new AnnotationConfiguration();
        config.configure(new File("src/main/resources/hibernate.cfg.xml"));
        factory = config.buildSessionFactory();
    }

    @Test
    public void test() {
        long id = setupData();

        Session hibernateSession1 = factory.openSession();
        hibernateSession1.beginTransaction();

        TestClass1 testClass1 = (TestClass1) hibernateSession1.get(TestClass1.class, id);

        //Comment this out to make the test work
        testClass1.getTestClass2().getTitle();

        hibernateSession1.getTransaction().commit();
        hibernateSession1.close();

        Session hibernateSession2 = factory.openSession();
        hibernateSession2.beginTransaction();

        hibernateSession2.update(testClass1);

        //This is our workaround
        //hibernateSession2.flush();
        //hibernateSession2.evict(testClass1);

        testClass1 = (TestClass1) hibernateSession2.get(TestClass1.class, testClass1.getId());
        //POSSIBLE BUG: This line throws org.hibernate.LazyInitializationException: could not initialize proxy - no Session
        testClass1.getTestClass2().getTestClass3().getName();

        hibernateSession2.getTransaction().commit();
        hibernateSession2.close();
    }

    private long setupData() {
        Session hibernateSession = factory.openSession();
        hibernateSession.beginTransaction();

        TestClass3 testClass3 = new TestClass3();
        testClass3.setName("test3");
        hibernateSession.persist(testClass3);

        TestClass2 testClass2 = new TestClass2();
        testClass2.setTitle("test2");
        testClass2.setTestClass3(testClass3);
        hibernateSession.persist(testClass2);

        TestClass1 testClass1 = new TestClass1();
        testClass1.setTitle("test1");
        testClass1.setTestClass2(testClass2);
        hibernateSession.persist(testClass1);

        hibernateSession.getTransaction().commit();
        hibernateSession.close();

        return testClass1.getId();
    }
}
